/*
http://irisbachelard.free.fr/index.php?idPage=94#chap7
*/

#include <windows.h>
#include <stdio.h>

#define BUFFER 4096

bool executeCmdWithRedirection(char *command, char *fileDest)
{
   SECURITY_DESCRIPTOR sd;
   SECURITY_ATTRIBUTES sa;

   InitializeSecurityDescriptor(&sd, SECURITY_DESCRIPTOR_REVISION);
   SetSecurityDescriptorDacl(&sd, true, NULL, false);
   sa.nLength = sizeof(SECURITY_ATTRIBUTES);
   sa.bInheritHandle = true;
   sa.lpSecurityDescriptor = &sd;
   HANDLE hReadPipe;
   HANDLE hWritePipe;

   if (! CreatePipe(&hReadPipe, &hWritePipe, &sa, NULL))
      return false;

   STARTUPINFO si;
   memset(&si, 0, sizeof(STARTUPINFO));
   si.cb = sizeof(STARTUPINFO);
   si.dwFlags = STARTF_USESHOWWINDOW |STARTF_USESTDHANDLES;
   si.wShowWindow = SW_SHOW;
   si.hStdOutput = hWritePipe;
   si.hStdError = hWritePipe;

   PROCESS_INFORMATION pi;

   if ( ! CreateProcess(NULL, command, NULL, NULL, TRUE, 0, 0, 0, &si, &api) )
      return false;

   WaitForSingleObject(pi.hProcess, INFINITE);

   HANDLE hFichier;

   hFichier = CreateFile(fileDest, GENERIC_WRITE, NULL, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL, NULL);

   if( hFichier == INVALID_HANDLE_VALUE)
      return false;

   DWORD BytesRead ;

   DWORD lu;

   char dest[BUFFER];

   memset(dest, 0, BUFFER);

   DWORD byteAvail = 0;

   PeekNamedPipe(hReadPipe, NULL, 0, NULL, &byteAvail, NULL);

   if (!byteAvail) // la génération n'a rien produit
      return true;

   while (ReadFile(hReadPipe, dest, BUFFER, &BytesRead, NULL))
   {
         if (!BytesRead)
            break;

         WriteFile(hFichier, dest, BytesRead, &lu, NULL);

         PeekNamedPipe(hReadPipe, NULL, 0, NULL, &byteAvail, NULL);

         if (BytesRead<BUFFER || !byteAvail)
            break;
   }

   CloseHandle(hFichier);
   CloseHandle(hReadPipe);
   CloseHandle(hWritePipe);

   return true;
}
